MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0025732Open CASCADE[OCCT] OCCT:Visualizationpublic2015-01-21 19:222015-05-14 15:32
Reportersan 
Assigned Tobugmaster 
PrioritynormalSeveritymajor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.8.0 
Target Version[OCCT] 6.9.0Fixed in Version[OCCT] 6.9.0 
Summary0025732: Visualization, TKOpenGl - back face culling should not affect textured font rendering
DescriptionIf a closed solid is displayed in shading, and then some text labels are added to the interactive context (the sequence is critical - closed solid first, then text labels), the text is not drawn.
Displaying non-closed shaded shapes or transparent shaded shapes or wireframe shapes does not break the text rendering.

This makes me think that back face culling enabled automatically for closed shaded opaque solids interferes with normal text rendering.

The previously set face aspect with enabled back face culling is not overridden when OpenGl_Text element is drawn (it does not apply OpenGl_AspectFace even if it is set for the current OpenGl_Group containing OpenGl_Text - and this looks logical when everything works as expected). So presumably the order of vertices in text VBOs is inverse so back face culling suppresses text triangles.

But maybe OpenGl_Group should also restore OpenGL state after it has been rendered...though this would affect performance, naturally.
Steps To Reproduce1. Scenario that breaks text rendering (closed shaded solid displayed prior to text)

pload MODELING VISUALIZATION
box b -100 0 -200 50 100 200
vinit View1
vclear
vaxo
vdisplay b
vfit
vsetdispmode b 1
vdrawtext "Open\nCASCADE" 0 0 0 255 000 000 1 1 -45 1 50 1 Arial


2. Scenario that doesn't break text rendering (no closed solids displayed prior to text)

pload ALL
box b 1 2 3
explode b F
vinit
vsetdispmode 1
vdisplay b_1 b_2
vfit
# Text is drawn correctly by this line
vdrawtext "SAMPLE TEXT" 1 0 3 255 0 0 0 0 0 0 30 1
TagsNo tags attached.
Test case numberbugs vis(004) bug25732_1, bug25732_2
Attached Files

- Relationships
has duplicate 0025759closedbugmaster Community Texts are not visible in view when they are displayed after the display of a solid shape in shading mode 

-  Notes
(0036947)
git (administrator)
2015-02-02 12:19

Branch CR25732 has been created by kgv.

SHA-1: 6977a5f8272f712fa0221ea5bfabfb3a6d9c7c24


Detailed log of new commits:

Author: asl
Date: Mon Feb 2 12:17:39 2015 +0300

    0025732: Visualization, TKOpenGl - back face culling should not affect textured font rendering
    
    OpenGl_TextFormatter - orient triangles in normal counter-clockwise order (GL_CCW).
(0036948)
kgv (developer)
2015-02-02 12:20

Please test the patch in branch CR25732.
(0037193)
git (administrator)
2015-02-06 18:14

Branch CR25732 has been updated forcibly by apv.

SHA-1: 9e4e7273c0ae79ccebaaf2bc55d4c1c0fc598c02
(0037194)
apv (tester)
2015-02-06 18:15

Branch CR25732 has been rebased on the current master
(0037236)
git (administrator)
2015-02-09 15:00

Branch CR25732 has been updated by apv.

SHA-1: 3780caa57e1b294e1efdf85b84f6fb671e0c257c


Detailed log of new commits:

Author: apv
Date: Mon Feb 9 14:59:55 2015 +0300

    Test-cases for issue 0025732

(0037240)
apv (tester)
2015-02-09 16:23

Dear BugMaster,

Branch CR25732 from occt git-repository (and master from products git-repository) was compiled on Linux, MacOS and Windows platforms and tested.
SHA-1: 9e4e7273c0ae79ccebaaf2bc55d4c1c0fc598c02

Number of compiler warnings:
occt component:
   Linux: 18 (18 on master)
   Windows: 0 (0 on master)
products component :
   Linux: 11 (11 on master)
   Windows: 1 (1 on master)

Regressions/Differences:
Not detected

Testing cases:
bugs vis(004) bug25732_1 - OK
http://occt-tests/CR25732-master-occt/Debian60-64/bugs/vis/bug25732_1.html [^]
http://occt-tests/CR25732-master-occt/Windows-32-VC10/bugs/vis/bug25732_1.html [^]
bugs vis(004) bug25732_2 - OK
http://occt-tests/CR25732-master-occt/Debian60-64/bugs/vis/bug25732_2.html [^]
http://occt-tests/CR25732-master-occt/Windows-32-VC10/bugs/vis/bug25732_2.html [^]

Testing on Linux:
Total MEMORY difference: 86196062 / 86199660
Total CPU difference: 49687.23000000006 / 47876.709999999846

Testing on Windows:
Total MEMORY difference: 40648362 / 40658496
Total CPU difference: 32185.03125 / 32754.0
(0038570)
git (administrator)
2015-03-18 13:36

Branch CR25732 has been deleted by inv.

SHA-1: 3780caa57e1b294e1efdf85b84f6fb671e0c257c

- Related Changesets
occt: master 348ff753
Timestamp: 2015-02-12 08:22:22
Author: kgv
Committer: bugmaster
Details ] Diff ]
0025732: Visualization, TKOpenGl - back face culling should not affect textured font rendering

OpenGl_TextFormatter - orient triangles in normal counter-clockwise order (GL_CCW).

Test-cases for issue 0025732
mod - src/OpenGl/OpenGl_TextFormatter.cxx Diff ] File ]
add - tests/bugs/vis/bug25732_1 Diff ] File ]
add - tests/bugs/vis/bug25732_2 Diff ] File ]

- Issue History
Date Modified Username Field Change
2015-01-21 19:22 san New Issue
2015-01-21 19:22 san Assigned To => kgv
2015-01-21 19:26 san Relationship added related to 0025132
2015-01-21 19:26 san Relationship added related to 0024903
2015-01-21 19:50 san Assigned To kgv => asl
2015-01-21 19:50 san Status new => assigned
2015-01-21 19:51 san Relationship added child of 0025724
2015-01-21 19:51 san Relationship deleted child of 0025724
2015-01-21 19:52 san Relationship added has duplicate 0025724
2015-01-28 16:51 kgv Relationship added has duplicate 0025759
2015-02-02 12:14 kgv Severity minor => major
2015-02-02 12:14 kgv Product Version => 6.8.0
2015-02-02 12:14 kgv Summary Visualization, TKOpenGl - Automatic back face culling suspected of killing text rendering => Visualization, TKOpenGl - back face culling should not affect textured font rendering
2015-02-02 12:14 kgv Steps to Reproduce Updated View Revisions
2015-02-02 12:19 git Note Added: 0036947
2015-02-02 12:20 kgv Note Added: 0036948
2015-02-02 12:20 kgv Assigned To asl => bugmaster
2015-02-02 12:20 kgv Status assigned => resolved
2015-02-02 12:20 kgv Status resolved => reviewed
2015-02-06 15:25 apv Assigned To bugmaster => apv
2015-02-06 18:14 git Note Added: 0037193
2015-02-06 18:15 apv Note Added: 0037194
2015-02-09 15:00 git Note Added: 0037236
2015-02-09 15:00 apv Test case number => bugs vis(004) bug25732_1, bug25732_2
2015-02-09 16:23 apv Note Added: 0037240
2015-02-09 16:23 apv Assigned To apv => bugmaster
2015-02-09 16:23 apv Status reviewed => tested
2015-02-13 17:55 bugmaster Changeset attached => occt master 348ff753
2015-02-13 17:55 bugmaster Status tested => verified
2015-02-13 17:55 bugmaster Resolution open => fixed
2015-03-18 13:36 git Note Added: 0038570
2015-05-14 15:29 aiv Status verified => closed
2015-05-14 15:32 aiv Fixed in Version => 6.9.0


Copyright © 2000 - 2019 MantisBT Team
Powered by Mantis Bugtracker